
#include "guilog.h"


void guilog_cl::RcodeToString(rcode retU, wxString& str) {
   str.Printf(_("RCODE: scope=%d, rcode=%d, data=%d [0x%04X]"),
               retU.detail.scope, retU.detail.rcode, retU.detail.data, retU.detail.data);
}

void guilog_cl::PrintRcode(rcode retU) {
   RcodeToString(retU, slog);
   DoLog();
};

void guilog_cl::DoLog() {
   wxLogStatus(slog.GetData());
   slog.Empty();
};

void guilog_cl::DoLog(const wxString& msg) {
   wxLogStatus(msg.GetData());
};

rcode guilog_cl::Create(wxWindow *parent, int w, int h) {
   rcode retU;

   if ((status != 0) || (logwin != NULL)) {
      retU = RCD_SET_VAL(scGUI_LOG, RCD_F, __LINE__);
      return retU;
   }
   logwin = new wxLogWindow(parent, _("LOG"), false);
   if (logwin == NULL) {
      retU = RCD_SET_VAL(scGUI_LOG, RCD_F, __LINE__);
      return retU;
   }
   logwin->GetFrame()->SetSize(wxDefaultCoord, wxDefaultCoord, w, h);
   status++ ;
   retU = RCD_SET_VAL(scGUI_LOG, RCD_OK, __LINE__);
   return retU;
};

rcode guilog_cl::Destroy() {
   rcode retU;

   if ((status != 0) && (logwin != NULL)) {
      wxFrame * frm = logwin->GetFrame();
      if (frm != NULL) frm->Destroy();
      retU = RCD_SET_VAL(scGUI_LOG, RCD_OK, __LINE__);
      return retU;
   }
   retU = RCD_SET_VAL(scGUI_LOG, RCD_F, __LINE__);
   return retU;
};

void guilog_cl::Show() {
   if ((status != 0) || (logwin != NULL)) {
      logwin->Show(true);
   }
};

void guilog_cl::ShowHide() {
   if ((status != 0) || (logwin != NULL)) {
      logwin->Show(! logwin->GetFrame()->IsShownOnScreen());
   }
   //visible = logwin->GetFrame()->IsShownOnScreen();
};

guilog_cl::guilog_cl(): status(0), logwin(NULL) {};

guilog_cl::~guilog_cl() {
   if ((status != 0) && (logwin != NULL)) {
      //logwin->GetFrame()->Destroy(); //fixme: crash.
   }
};

guilog_cl guilog;
